<script lang="ts">
import { defineComponent, inject } from 'vue';
import {
  useDialogsStore,
  DynamicDialog,
} from '@new-jira-clone/ui/src/composables/store/useDialogsStore';
import { DialogPlugin } from '@new-jira-clone/ui/src/plugins/dialog';
import JDialog from './JDialog.vue';

export default defineComponent({
  name: 'JDialogsContainer',
  components: {
    JDialog,
  },
  setup() {
    const $dialog = inject('$dialog') as DialogPlugin;
    const { dynamicDialogs, removeDynamicDialog } = useDialogsStore();

    const onUpdateModel = (model: boolean, dialog: DynamicDialog) => {
      if (model) {
        dialog.model = true;
      } else if (dialog.type === 'nonModal') {
        $dialog.close(dialog.id);
      } else {
        removeDynamicDialog(dialog);
      }
    };

    return { dynamicDialogs, onUpdateModel };
  },
});
</script>

<template>
  <JDialog
    v-for="dynamicDialog in dynamicDialogs"
    :key="dynamicDialog.id"
    v-bind="dynamicDialog.options.dialogProps"
    :type="dynamicDialog.type"
    :z-index="dynamicDialog.zIndex"
    :model-value="dynamicDialog.model"
    @update:model-value="onUpdateModel($event, dynamicDialog)"
  >
    <component
      v-bind="dynamicDialog.options.contentProps"
      :is="dynamicDialog.component"
      :dialog-id="dynamicDialog.id"
    />
  </JDialog>
</template>
